var nord01 = "#3B4252";
var nord11 = "#BF616A";
var nord12 = "#D08770";

var xoff = 0;

function CIRCLE() {
    this.pos = p5.Vector.random2D();
    this.pos.setMag(min(width/2,height/2)/3);
    var intensity = random (2, 10);
    this.draw = function() {
        ellipse (this.pos.x, this.pos.y,
                 intensity, intensity);
    };
    // randomly update the intensity
    this.updateIntensity = function(t) {
        intensity = map(noise(t, this.pos.x, this.pos.y),0,1,0,27);
    };
    // push the CIRCLE in a random direction
    this.updateXY = function () {
        var rv = p5.Vector.fromAngle(
            map(noise(this.pos.x, this.pos.y),
                0,1,0.1, 7*TWO_PI));
        rv.setMag(3);
        this.pos.add(rv);
    };
    // set uniformly random coordinates
    this.newXY = function() {
        this.pos.x = random (-width/2, width/2);
        this.pos.y = random (-height/2, height/2);
    };
}

function bgsetup () {
    background(nord01);
    stroke(nord11);
    fill(255);
}

var circles = new Array(100);
var LOG;
var touched = false;

function setup() {
    var cnvs = createCanvas(windowWidth-40, windowHeight-80);
    // cnvs.touchStarted(function() { touched = true; });
    // cnvs.touchEnded(function() { touched = false; });
    bgsetup();
    for (var i = 0; i < 100; i++)
        circles[i] = new CIRCLE();

    createP('Hold mouse button for movement; press spacebar for a new configuration.');
    createA('https://www.youtube.com/watch?v=eGUzKc_h5E0', 'eat your broccoli');
    //LOG = createP('');
}

function touchStarted() { touched = true; };
function touchEnded() { touched = false; };

function keyPressed() {
    bgsetup();
    for (var i = 0; i < 100; i++)
        circles[i].newXY();
}


function draw() {
    background(nord01);
    translate(width/2, height/2);
    for (var i = 0; i < 100; i++)
    {
        if (touched) circles[i].updateXY();
        circles[i].draw();
        circles[i].updateIntensity(xoff);
    }
    xoff += 0.01;

    //LOG.html(floor(frameRate()));
}
