var nord00 = "#2e3440";
var nord01 = "#3B4252";
var nord02 = "#434c5e";
var nord03 = "#4c566a";
var nord10 = "#5e81ac";
var nord11 = "#BF616A";
var nord12 = "#D08770";

var dt = 0;
var rd = [];
var sz = 10;

// HTML controls
var LOG;

function setup()
{
    var s = min(windowHeight,windowWidth) - 20;
    //createCanvas(s,s-50);
    createCanvas(1000,windowHeight-70);
    background(nord01);
    stroke(nord11);
    fill(nord03);

    generateRd();

    LOG = createP('');
}

function sun(x, y, growth, t) {
    push();
    for (var i = 0; i < 10; i++) {
        var j = (i+t)%10;
        fill(255-j*20,200-j*20,1);
        ellipse(x,y,100-i*15+growth,100-i*15+growth);
    }
    pop();
}

function accumulate(xs) {
    var ys = xs.slice();
    for (var i = 1; i < ys.length; i++) {
        ys[i] = ys[i] + ys[i-1];
    }
    return ys;
}

function addlists(xs, ys) {
    var s = min(xs.length, ys.length);
    var zs = new Array();
    for (var i = 0; i < s; i++) {
        zs.push(xs[i]+ys[i]);
    }
    return zs;
}

function weighted(xs,w) {
    return _.map(xs, function(x){return x*w;});
}

function generateRd() {
    for (var i = 0; i < sz+1; i++) {
        rd[i] = random(-1,1);
    }
}

function outputRd(rd, offset) {
    push();
    translate(0,offset);
    noFill();
    beginShape();
    _.each(rd, function(v,i){
        vertex(i*width/sz,v*100);
    });
    endShape();
    pop();
}

function draw()
{
    background(nord01);
    
    // draw the sun
    var growth = noise(dt/5)*200;    
    sun(width-150,150,growth,dt);
    dt += 0.05;

    stroke(nord03);
    outputRd(rd, height/2);

    var rdb = weighted(accumulate(rd),0.6);
    stroke(nord10);
    outputRd(rdb, height/2);

    stroke(nord11);
    var rdc = addlists(weighted(rd,0.25),rdb);
    outputRd(rdc, height/2);

    var rde = new Array();
    for(var i = 0; i < sz+1; i++) {
        rde[i] = map(noise(i/10,dt),0,1,-1,1);
    }
    stroke(nord12);
    outputRd(addlists(weighted(rde,0.5), rdc), height/2);


    //noLoop();
    LOG.html(floor(frameRate()));
}
